
import commonj.sdo.DataObject;

import com.ibm.websphere.bo.BOFactory;
import com.ibm.websphere.sca.ServiceManager;

public class AccountServicesJavaImpl1 {
	/**
	 * Default constructor.
	 */
	public AccountServicesJavaImpl1() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation "createNewAccount" defined for WSDL port type 
	 * named "AccountServicesInterface".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject createNewAccount(DataObject newAccountInfo) {
		// To get or set attributes for DataObject newAccountInfo, use the APIs as shown below:
		// To set a string attribute in newAccountInfo, use newAccountInfo.setString(stringAttributeName, stringValue)
		// To get a string attribute in newAccountInfo, use newAccountInfo.getString(stringAttributeName)
		// To set a dataObject attribute in newAccountInfo, use newAccountInfo.setDataObject(stringAttributeName, dataObjectValue)
		// To get a dataObject attribute in newAccountInfo, use newAccountInfo.getDataObject(stringAttributeName)
		newAccountInfo.setString("Status", "new");
		System.out.println("************ New Account Created *****");
		return newAccountInfo;
	}

	/**
	 * Method generated to support implementation of operation "deleteAccount" defined for WSDL port type 
	 * named "AccountServicesInterface".
	 * 
	 * Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public String deleteAccount(String accountId, String reason) {
		//TODO Needs to be implemented.

		System.out.println("************ Account deleted: " + accountId + "reason: " + reason + " *****");
		return "Account: " + accountId + " deleted";
	}

	/**
	 * Method generated to support implementation of operation "accountStatus" defined for WSDL port type 
	 * named "AccountServicesInterface".
	 * 
	 * Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public String accountStatus(String accountId) {

		String status = new String("questionable");
		
		if (accountId.equals("a12345")) status = "good";
		return status;
	}

	/**
	 * Method generated to support implementation of operation "addAccountFeature" defined for WSDL port type 
	 * named "AccountServicesInterface".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public String addAccountFeature(String accountId, DataObject newFeature) {
		// To get or set attributes for DataObject newFeature, use the APIs as shown below:
		// To set a string attribute in newFeature, use newFeature.setString(stringAttributeName, stringValue)
		// To get a string attribute in newFeature, use newFeature.getString(stringAttributeName)
		// To set a dataObject attribute in newFeature, use newFeature.setDataObject(stringAttributeName, dataObjectValue)
		// To get a dataObject attribute in newFeature, use newFeature.getDataObject(stringAttributeName)
		return "This service has not be implemented yet";
	}

	/**
	 * Method generated to support implementation of operation "getAccountInfo" defined for WSDL port type 
	 * named "AccountServicesInterface".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject getAccountInfo(String accountId, String requestorInfo) {

		ServiceManager serviceManager = new ServiceManager();
		BOFactory bof = (BOFactory) serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
		
		DataObject theAccount = bof.createByMessage("http://AccountServices/AccountServices/AccountInfo", "AccountInfo");
		
		theAccount.setString("AccountId", accountId);
		theAccount.setString("Name", "Some name");
		theAccount.setString("Address", "2345 SW. Seattle, WA");
		theAccount.setString("Status", "new");
			
		return theAccount;
	}

}